# -*- coding: utf-8 -*-
#Skript for å sjekke om stack allerede eksisterer i CloudFormation
#eksekverer deretter riktig skript videre.
from __future__ import print_function
import os
import sys
import json
import argparse
import boto3
import appconfig
import os
from botocore.exceptions import ClientError

parser = argparse.ArgumentParser(description='URL for imaget som skal bruke i Fargate')
parser.add_argument("ImageURL", help="Maa vaere tilgjengelig Docker Image for ECS", type=str)
args = parser.parse_args()

stackexsist = None

#Etablerer Client-Server tilkobling mot AWS CloudFormation sitt API
cf_client = boto3.client('cloudformation')
print("Boto3 Client Created")

response = cf_client.list_stacks()
for stack in response["StackSummaries"]:
    if stack['StackName'] == appconfig.stack['stackname'] and stack['StackStatus'] == "CREATE_COMPLETE":
        print('Found exsisting service stack: '+ appconfig.stack['stackname'])
        stackexsist = True
        os.system("python aws/updateService.py "+ args.ImageURL)
if stackexsist == None:
    print('Did not find exsisting stack, creating new stack named: ' + appconfig.stack['stackname'])
    os.system("python aws/createService.py "+ args.ImageURL)
