# -*- coding: utf-8 -*-
#Python script for aa implementere en ny service med confg fra appconfig.py
from __future__ import print_function
import os
import sys
import json
import argparse
import boto3
import appconfig
from botocore.exceptions import ClientError

cf_client = boto3.client('cloudformation')
print("Boto3 Client Created")

print("Creating ServiceStack...")
with open("aws/taskdefinition.yaml") as template:
    response = cf_client.create_stack(
        StackName=appconfig.stack['stackname'],
        TemplateBody=template.read(), 
        Parameters=[
            {
                'ParameterKey' : 'ClusterName',
                'ParameterValue' : appconfig.cluster['cluster_name']
            },
            {
                'ParameterKey' : 'ServiceName',
                'ParameterValue' : appconfig.service['service_name']
            },
            {
                'ParameterKey' : 'TaskDefinition',
                'ParameterValue' : appconfig.task['definition']
            },
            {
                'ParameterKey' : 'TaskAmount',
                'ParameterValue' : appconfig.service['task_amount']
            },
            {
                'ParameterKey' : 'MaxHealth',
                'ParameterValue' : appconfig.service['max_percent']
            },
            {
                'ParameterKey' : 'MinHealth',
                'ParameterValue' : appconfig.service['min_percent']
            },
            {
                    'ParameterKey' : 'TaskCpuAmount',
                'ParameterValue' : appconfig.task['task_cpu']
            },
            {
                'ParameterKey' : 'TaskMemoryAmount',
                'ParameterValue' : appconfig.task['task_memory']
            },
            {
                'ParameterKey' : 'ContainerPort',
                'ParameterValue' : appconfig.container1['container_port']
            },
            {
                'ParameterKey' : 'ContainerCpuAmount',
                'ParameterValue' : appconfig.container1['container_cpu_amount']
            },
            {
                'ParameterKey' : 'ContainerMemoryAmount',
                'ParameterValue' : appconfig.container1['container_memory']
            },
            {
                'ParameterKey' : 'LoadBalancerPort',
                'ParameterValue' : appconfig.container1['loadbalancer_port']
            },
            {
                'ParameterKey' : 'PortProtocol',
                'ParameterValue' : appconfig.container1['protocol']
            },
            {
                'ParameterKey' : 'ContainerName',
                'ParameterValue' : appconfig.container1['name']
            },
            {
                'ParameterKey' : 'ImageURL',
                'ParameterValue' : str(sys.argv[1])
            },
            {
                'ParameterKey' : 'MaxScale',
                'ParameterValue' : appconfig.service['max_scale']
            },
            {
                'ParameterKey' : 'MinScale',
                'ParameterValue' : appconfig.service['min_scale']
            },
        ]       
    )

